//---------------------------------------------------------------------------

#ifndef utilsH
#define utilsH

//---------------------------------------------------------------------------
//custom exception class
class ECustomException : public Exception
{
private:
    String FCallingFunction, FExceptionType, FNewMessage;
    TDateTime FTime;

    String __fastcall FGetTime();
    String __fastcall SortOutWin32ErrorMessage(String sMessage);
public:
    __fastcall ECustomException(String sFunc, String sType, String sMessage);
    __fastcall ~ECustomException(){/*inline empty*/};
    String __fastcall ErrorString();
    //properties, all read only
    __property String CallingFunction = {read=FCallingFunction};
    __property String ExceptionType = {read=FExceptionType};
    __property String NewMessage = {read=FNewMessage};
    __property String Time = {read=FGetTime};
};
//---------------------------------------------------------------------------
//simple helper functions
void __fastcall PosForm(TForm *sForm, TAlign sAlign);
void __fastcall LogError(Exception *sException);
String __fastcall GetParentFolder();
#endif

